header {* Constructing list-of-exceptions monad by composition *}

theory ExnListMonad
imports "../../../Extensions/AWE_HOL"
begin


text {* Get an instance of the list monad *}
thymorph i : Main \<longrightarrow> ExnListMonad
instantiate_theory ListMonad by_thymorph i 
renames: [("ListMonad.bind" \<mapsto> list_bind),
          ("ListMonad.bind'" \<mapsto> list_bind'),
          ("ListMonad.eta" \<mapsto> list_eta),
          ("ListMonad.mapM" \<mapsto> list_mapM),
          ("ListMonad.joinM" \<mapsto> list_joinM),
          ("ListMonad.bind_def" \<mapsto> list_bind_def),
          ("ListMonad.bind'_def" \<mapsto> list_bind'_def),
          ("ListMonad.eta_def" \<mapsto> list_eta_def),
          ("ListMonad.mapM_def" \<mapsto> list_mapM_def),
          ("ListMonad.joinM_def" \<mapsto> list_joinM_def)]
without_syntax

thymorph list_inst by_composition i' \<circ> list_monad
renames: [("ListMonad.runit" \<mapsto> list_runit),
          ("ListMonad.MonadAxms_mon_lunit" \<mapsto> list_lunit),
          ("ListMonad.MonadAxms_mon_eta_inj" \<mapsto> list_eta_inj),
          ("ListMonad.assoc" \<mapsto> list_assoc)]


text {* Applying the ExnT transformation to lists *}

thymorph exnT_p_i : ExnT_P \<longrightarrow> ExnListMonad
type_map: [("'a M1" \<mapsto> "'a list")]

text {* The syntax is imported from here *}
instantiate_theory ExnT by_thymorph exnT_p_i

thymorph exn_list_monad by_composition exnT_p_i' \<circ> exnT_monad

instantiate_theory "../MonadBase" by_thymorph exn_list_monad
translate_thm "MonadBase.joinM_eta" along exn_list_monad'
translate_thm "MonadBase.joinM_mapM_joinM"  along exn_list_monad'


end