
theory QuotientType_Parameters
imports Equiv_Relations Hilbert_Choice
begin

text{*
The type constructor @{text "T"} is the first formal parameter.
*}

typedecl 'a T

text{* 
The equivalence relation @{text "eqR"} on @{typ "'a T"} is the second formal parameter. 
*}

consts
 eqR :: "'a T \<times> 'a T \<Rightarrow> bool" 

syntax
 eqR_ :: "'a T \<Rightarrow> 'a T \<Rightarrow> bool"   ("_/ \<simeq> _"  [50, 51] 50)
translations
"a \<simeq> b" == "(a, b) \<in> eqR"


axioms
 eqR_refl  : "a \<simeq> a"
 eqR_trans : "a \<simeq> b \<Longrightarrow> b \<simeq> c \<Longrightarrow> a \<simeq> c"
 eqR_sym   : "a \<simeq> b \<Longrightarrow> b \<simeq> a"


end